﻿Imports Telerik.Windows.Controls

Public Class ListBoxAttachedbehavior
    Public Shared Function GetSelectionChangedAttachedProperty(obj As DependencyObject) As Boolean
        Return CBool(obj.GetValue(SelectionChangedAttachedPropertyProperty))
    End Function

    Public Shared Sub SetSelectionChangedAttachedProperty(obj As DependencyObject, value As Boolean)
        obj.SetValue(SelectionChangedAttachedPropertyProperty, value)
    End Sub

    Public Shared ReadOnly SelectionChangedAttachedPropertyProperty As DependencyProperty = DependencyProperty.RegisterAttached("SelectionChangedAttachedProperty", GetType(Boolean), GetType(ListBoxAttachedbehavior), New PropertyMetadata(AddressOf onSelectionChangedPropertyApplied))

    Private Shared Sub onSelectionChangedPropertyApplied(d As DependencyObject, e As DependencyPropertyChangedEventArgs)
        Dim lb = TryCast(d, ListBox)
        AddHandler lb.SelectionChanged, AddressOf Lb_SelectionChanged
    End Sub

    Private Shared Sub Lb_SelectionChanged(sender As Object, e As SelectionChangedEventArgs)
        Dim lb = TryCast(sender, ListBox)
        Dim carousel = lb.ParentOfType(Of DockPanel)().ChildrenOfType(Of RadCarousel)().FirstOrDefault()
        If carousel IsNot Nothing Then
            carousel.BringDataItemIntoView(lb.SelectedItem)
            carousel.SelectedItem = lb.SelectedItem
        End If
    End Sub
End Class
